LibreOffice: OfficeDatabaseDocument Service Reference

LibreOffice LibreOffice 5.2 SDK API Reference

Included Services | Exported Interfaces | List of all members
OfficeDatabaseDocument Service Reference

specifies a office database document which is a storable document. More...

`import"OfficeDatabaseDocument.idl";`

Inheritance diagram for OfficeDatabaseDocument:

## Included Services
service | com::sun::star::document::OfficeDocument
| specifies basic functionality of a document in OpenOffice.org More...

## Exported Interfaces
interface | XOfficeDatabaseDocument
interface | ::com::sun::star::document::XEmbeddedScripts
| allows access to the Basic macros and dialogs possibly embedded in the document More...
interface | ::com::sun::star::script::provider::XScriptProviderSupplier
| supplies a script provider which can be used to execute macros and scripts embedded in the document More...
interface | ::com::sun::star::frame::XLoadable
| allows to initialize the document, either from scratch, or from a stored database document. More...
interface | ::com::sun::star::document::XDocumentEventBroadcaster
| allows to register for notifications happening in the document More...
interface | com::sun::star::util::XCloseable
| implements life time control More...
Exported Interfaces inherited from OfficeDocument
interface | com::sun::star::frame::XModel
| represents a component which is created from an URL and arguments More...
interface | com::sun::star::util::XModifiable
| a storable document should provide information about his modify state More...
interface | com::sun::star::frame::XStorable
| offers a simple way to store a component to an URL More...
interface | com::sun::star::view::XPrintable
| offers a way to print a component More...
interface | XEventBroadcaster
| is an old and deprecated version of the XDocumentEventBroadcaster interface More...
interface | XDocumentEventBroadcaster
| makes it possible to register listeners which are called whenever a document event occurs More...
interface | XEventsSupplier
| access to bound event handlers More...
interface | XViewDataSupplier
| access to some properties describing all open views to a document More...
interface | com::sun::star::view::XPrintJobBroadcaster
| allows for getting information about a print job More...
interface | XEmbeddedScripts
| is supported when the document can contain scripts and dialogs More...
interface | XDocumentPropertiesSupplier
| access to the DocumentProperties. More...
interface | XUndoManagerSupplier
| provides access to the document's undo manager. More...
Exported Interfaces inherited from XOfficeDatabaseDocument
interface | com::sun::star::sdb::XFormDocumentsSupplier
| allows to access the supplier for forms. More...
interface | com::sun::star::sdb::XReportDocumentsSupplier
| allows to access the supplier for reports. More...
interface | com::sun::star::document::XDocumentSubStorageSupplier
| allows the access to all sub storages in the office database document. More...

## Additional Inherited Members
Public Member Functions inherited from XModel
boolean | attachResource ([in] string URL, [in] sequence< com::sun::star::beans::PropertyValue > Arguments)
| informs a model about its resource description. More...
string | getURL ()
| provides information about the location of this model More...
sequence< com::sun::star::beans::PropertyValue > | getArgs ()
| provides read access on currently representation of the com::sun::star::document::MediaDescriptor of this model which describes the model and his state More...
void | connectController ([in] XController Controller)
| is called whenever a new controller is created for this model. More...
void | disconnectController ([in] XController Controller)
| is called whenever an existing controller should be deregistered at this model. More...
void | lockControllers ()
| suspends some notifications to the controllers which are used for display updates. More...
void | unlockControllers ()
| resumes the notifications which were suspended by XModel::lockControllers(). More...
boolean | hasControllersLocked ()
| determines if there is at least one lock remaining. More...
XController | getCurrentController ()
| provides access to the controller which currently controls this model More...
void | setCurrentController ([in] XController Controller) raises ( com::sun::star::container::NoSuchElementException )
| sets a registered controller as the current controller. More...
com::sun::star::uno::XInterface | getCurrentSelection ()
| provides read access on current selection on controller More...
Public Member Functions inherited from XComponent
void | dispose ()
| The owner of an object calls this method to explicitly free all resources kept by this object and thus break cyclic references. More...
void | addEventListener ([in] XEventListener xListener)
| adds an event listener to the object. More...
void | removeEventListener ([in] XEventListener aListener)
| removes an event listener from the listener list. More...
Public Member Functions inherited from XInterface
any | queryInterface ([in] type aType)
| queries for a new interface to an existing UNO object. More...
void | acquire ()
| increases the reference counter by one. More...
void | release ()
| decreases the reference counter by one. More...
Public Member Functions inherited from XModifiable
boolean | isModified ()
void | setModified ([in] boolean bModified) raises ( com::sun::star::beans::PropertyVetoException )
| sets the status of the modified-flag from outside of the object. More...
Public Member Functions inherited from XModifyBroadcaster
void | addModifyListener ([in] com::sun::star::util::XModifyListener aListener)
| adds the specified listener to receive events "modified." More...
void | removeModifyListener ([in] com::sun::star::util::XModifyListener aListener)
| removes the specified listener. More...
Public Member Functions inherited from XStorable
boolean | hasLocation ()
| The object may know the location because it was loaded from there, or because it is stored there. More...
string | getLocation ()
| After XStorable::storeAsURL() it returns the URL the object was stored to. More...
boolean | isReadonly ()
| It is not possible to call XStorable::store() successfully when the data store is read-only. More...
void | store () raises ( com::sun::star::io::IOException )
| stores the data to the URL from which it was loaded. More...
void | storeAsURL ([in] string sURL, [in] sequence< com::sun::star::beans::PropertyValue > lArguments) raises ( com::sun::star::io::IOException )
| stores the object's persistent data to a URL and makes this URL the new location of the object. More...
void | storeToURL ([in] string sURL, [in] sequence< com::sun::star::beans::PropertyValue > lArguments) raises ( com::sun::star::io::IOException )
| stores the object's persistent data to a URL and continues to be a representation of the old URL. More...
Public Member Functions inherited from XPrintable
sequence< com::sun::star::beans::PropertyValue > | getPrinter ()
void | setPrinter ([in] sequence< com::sun::star::beans::PropertyValue > aPrinter) raises ( com::sun::star::lang::IllegalArgumentException )
| assigns a new printer to the object. More...
void | print ([in] sequence< com::sun::star::beans::PropertyValue > xOptions) raises ( com::sun::star::lang::IllegalArgumentException )
| prints the object. More...
Public Member Functions inherited from XFormDocumentsSupplier
com::sun::star::container::XNameAccess | getFormDocuments ()
| returns the container of forms. More...
Public Member Functions inherited from XReportDocumentsSupplier
com::sun::star::container::XNameAccess | getReportDocuments ()
| returns the container of reports. More...
Public Member Functions inherited from XDocumentSubStorageSupplier
com::sun::star::embed::XStorage | getDocumentSubStorage ([in] string StorageName, [in] long nMode)
| provides the access to a substorage with specified name More...
sequence< string > | getDocumentSubStoragesNames () raises ( ::com::sun::star::io::IOException )
| provides the list of substorages More...
Public Member Functions inherited from XScriptProviderSupplier
XScriptProvider | getScriptProvider ()
| returns scripting provider related to the object. More...
Public Member Functions inherited from XLoadable
void | initNew () raises ( DoubleInitializationException, com::sun::star::io::IOException, com::sun::star::uno::Exception )
| creates a component from scratch More...
void | load ([in] sequence< com::sun::star::beans::PropertyValue > lArguments) raises ( DoubleInitializationException, com::sun::star::io::IOException, com::sun::star::uno::Exception )
| loads a component from an URL More...
Public Member Functions inherited from XCloseable
void | close ([in] boolean DeliverOwnership) raises ( CloseVetoException )
| try to close the object More...
Public Member Functions inherited from XCloseBroadcaster
void | addCloseListener ([in] XCloseListener Listener)
| adds the specified listener to receive or have a veto for "close" events More...
void | removeCloseListener ([in] XCloseListener Listener)
| removes the specified listener More...
Public Attributes inherited from OfficeDocument
boolean | AutomaticControlFocus
| controls the focus behavior of the form controls in the document More...
boolean | ApplyFormDesignMode
| controls the initial (on-load) behavior of the form controls in the document More...
string | RuntimeUID
| contains a unique id for the document More...
sequence< com::sun::star::beans::PropertyValue > | InteropGrabBag
| Grab bag of document properties, used as a string-any map for interim interop purposes. More...
Public Attributes inherited from XOfficeDatabaseDocument
com::sun::star::sdbc::XDataSource | DataSource
| provides access to the one and only DataSource associated with this document More...
Protected Member Functions inherited from XEventBroadcaster
void | addEventListener ([in] XEventListener Listener)
| registers the given listener More...
void | removeEventListener ([in] XEventListener Listener)
| unregisters the given listener More...
Protected Member Functions inherited from XDocumentEventBroadcaster
void | addDocumentEventListener ([in] XDocumentEventListener Listener)
| registers a listener which is notified about document events More...
void | removeDocumentEventListener ([in] XDocumentEventListener Listener)
| revokes a listener which has previously been registered to be notified about document events. More...
void | notifyDocumentEvent ([in] string EventName, [in] ::com::sun::star::frame::XController2 ViewController, [in] any Supplement) raises ( ::com::sun::star::lang::IllegalArgumentException, ::com::sun::star::lang::NoSupportException )
| causes the broadcaster to notify all registered listeners of the given event More...
Protected Member Functions inherited from XEventsSupplier
com::sun::star::container::XNameReplace | getEvents ()
| offers a list of event handlers which are be bound to events of this object More...
Protected Member Functions inherited from XViewDataSupplier
::com::sun::star::container::XIndexAccess | getViewData ()
| retrieve information about currently opened view to restore it later More...
void | setViewData ([in] com::sun::star::container::XIndexAccess Data)
| restore all views which will be represented by given data argument More...
Protected Member Functions inherited from XPrintJobBroadcaster
void | addPrintJobListener ([in] XPrintJobListener xListener)
| adds an XPrintJobListener to be notified about print progress. More...
void | removePrintJobListener ([in] XPrintJobListener xListener)
| removes an XPrintJobListener. More...
Protected Member Functions inherited from XDocumentPropertiesSupplier
XDocumentProperties | getDocumentProperties ()
| provides the document properties object. More...
Protected Member Functions inherited from XUndoManagerSupplier
XUndoManager | getUndoManager ()
| returns the Undo manager associated with the component. More...
Protected Attributes inherited from XEmbeddedScripts
::com::sun::star::script::XStorageBasedLibraryContainer | BasicLibraries
| is the container of `StarBasic` macro libraries contained in the document More...
::com::sun::star::script::XStorageBasedLibraryContainer | DialogLibraries
| is the container of dialogs libraries contained in the document More...
boolean | AllowMacroExecution
| determines whether executing macros from this document is allowed. More...

## Detailed Description

specifies a office database document which is a storable document.

These documents contain information about forms, and reports, and the properties of a data source.

The database document contains no data per default. The following is stored inside the document:

- forms
- reports
- The table settings defined in DataSettings
- The query settings defined in DataSettings
- All properties of the service DataSource

See also
  com::sun::star::sdb::XOfficeDatabaseDocument
  com::sun::star::document::OfficeDocument

Since
  OOo 2.0

## Exported Interfaces

## ◆ com::sun::star::document::OfficeDocument

service com::sun::star::document::OfficeDocument

specifies basic functionality of a document in OpenOffice.org

Note that a database document actually does not support the com::sun::star::view::XPrintable interface. The non-optional requirement of this interface in the com::sun::star::document::OfficeDocument service is considered a documentation error.

## Exported Interfaces

## ◆ ::com::sun::star::document::XDocumentEventBroadcaster

interface ::com::sun::star::document::XDocumentEventBroadcaster

allows to register for notifications happening in the document

The following events are broadcasted by a database document

Event Name | broadcasted when | broadcasted synchronously
OnCreate | the document has been newly created. This does not imply that the document has been loaded into a frame, it just means the initialization has been finished. | yes
OnLoadFinished | the document has been completely loaded. This does not imply that the document has been loaded into a frame, it just means the load process has been finished. | yes
OnNew | the document has been initialized from scratch, including plugging it into a frame. | no
OnLoad | the document has been completely loaded, including plugging it into a frame. | no
OnSave | the document is about to be saved. | yes
OnSaveDone | saving the document succeeded. | no
OnSaveFailed | saving the document failed. | no
OnSaveAs | the document is about to be saved under a new name. | yes
OnSaveAsDone | saving the document under a new name succeeded. | no
OnSaveAsFailed | saving the document under a new name failed. | no
OnSaveTo | the document is about to be saved to a location different from its current location, but without adjusting the current location. | yes
OnSaveToDone | saving the document to a different location succeeded. | no
OnSaveToFailed | saving the document to a different location failed. | no
OnPrepareUnload | the document is about to be closed. | yes
OnUnload | the document is being closed. | yes
OnFocus | a view to the document obtained the focus. | no
OnUnfocus | a view to the document lost the focus. | no
OnModifyChanged | the modified state of the document changed. | no
OnViewCreated | a view to the document has been created, and attached to the document. | no
OnPrepareViewClosing | a view to the document is about to be closed. | yes
OnViewClosed | a view to the document has been closed. | no
OnTitleChanged | the title of the document changed. | no
OnSubComponentOpened | From with a view to the document, a view to a sub component (e.g. a table or a report) has been opened. | no
OnSubComponentClosed | From with a view to the document, a view to a sub component (e.g. a table or a report) has been closed. | no

Since
  OOo 3.1

## ◆ ::com::sun::star::document::XEmbeddedScripts

interface ::com::sun::star::document::XEmbeddedScripts

allows access to the Basic macros and dialogs possibly embedded in the document

Since
  OOo 3.1

## ◆ ::com::sun::star::frame::XLoadable

interface ::com::sun::star::frame::XLoadable

allows to initialize the document, either from scratch, or from a stored database document.

A newly instantiated database document cannot be operated until it is fully initialized. There are three possible means to do this initialization:

- calling `XLoadable::initNew`
- calling `XLoadable::load`
- calling `XStorable::storeAsURL`

The third option was added for compatibility reasons, since a DatabaseDocument in earlier versions of OpenOffice.org did not support the `XLoadable` interface, so the usual way of creating a document from scratch was to create it, set properties as needed, and store it.

Since
  OOo 3.1

## ◆ ::com::sun::star::script::provider::XScriptProviderSupplier

interface ::com::sun::star::script::provider::XScriptProviderSupplier

supplies a script provider which can be used to execute macros and scripts embedded in the document

Since
  OOo 3.1

## ◆ com::sun::star::util::XCloseable

interface com::sun::star::util::XCloseable

implements life time control

Whoever retrieves a OfficeDatabaseDocument should be aware of life time issues, since a document needs to be closed when nobody needs it anymore.

This implies that clients of a document need to ensure that as soon as they don't need, they invoke com::sun::star::util::XCloseable::close().

Since this can be done by multiple clients, every client is additionally required to register itself as com::sun::star::util::XCloseListener at the document, to prevent some other client closing the model while it's still needed by the first client.

## ◆ XOfficeDatabaseDocument

interface XOfficeDatabaseDocument

The documentation for this service was generated from the following file:

- com/sun/star/sdb/OfficeDatabaseDocument.idl